include get.e

constant e = 2.718281828459046
constant pi = 3.141592653589793238462643383279502

atom dx,dy,ordinates,integral,interval
interval = 0.01
ordinates = 80
integral = 0

function E(atom x)
    return power(e,x)
end function

function StandBiVariateVal(atom x, atom y, atom rho)
    return E(-(x*x-2*rho*x*y+y*y)/(2-2*rho*rho))
end function

function ToNum(sequence temp)

    atom res,ten,minus,decimal,dec
    sequence me

    minus = 1
    me = {}
    temp = temp[1..length(temp)-1]
    res = 0
    decimal = 0
    dec = 0

    if temp[1] = '-' then
        minus = -1
        temp = temp[2..length(temp)]
    end if

    for tem = 1 to length(temp) do

        if temp[tem]  = 46 then
	    decimal = tem-1
        end if

    end for

    if decimal > 0 then
        me = temp[1..decimal]
        temp = me & temp[decimal+2..length(temp)]
        dec = length(temp)-decimal
    end if

    ten = length(temp)-1

    for t = 1 to length(temp) do

        res += (temp[t]-48)*power(10,ten)
        ten -= 1

    end for

    res = res/(power(10,dec))

    return res*minus
end function

function GenBiVariateInt(sequence limits)

    atom ax,bx,ay,By,rho,mux,muy,sigmax,sigmay,z1,z3,a

    interval = 0.05
    mux = limits[1]
    muy = limits[3]
    sigmax = limits[2]
    sigmay = limits[4]
    ax = limits[6]
    bx = limits[5]
    ay = limits[8]
    By = limits[7]
    rho = limits[9]
    integral = 0

    if (bx-ax) > (By-ay) then
        ordinates = floor((bx-ax)/interval)
    else
        ordinates = floor((By-ay)/interval)
    end if

    if ordinates < 50 then
        ordinates = 50
    end if

    dy = (By-ay)/(ordinates*sigmay)
    dx = (bx-ax)/(ordinates*sigmax)

    a = (ax-mux)/sigmax
    z1 = a
    z3 = (ay-muy)/sigmay

    for ty = 0 to ordinates-1 do
        for tx = 0 to ordinates-1 do

	    integral += StandBiVariateVal(z1,z3,rho)
	    integral += StandBiVariateVal(z1,z3+dy,rho)

	    z1 += dx

	    integral += StandBiVariateVal(z1,z3,rho)
	    integral += StandBiVariateVal(z1,z3+dy,rho)

        end for

        z1 = a
        z3 += dy

    end for

    integral *= (dx*dy)/(8*pi*sqrt(1-rho*rho))

    return integral
end function

function GenNormalInt(sequence limits)
    atom ax,bx,mux,sigmax,z1

    mux = limits[1]
    sigmax = limits[2]
    ax = limits[4]
    bx = limits[3]
    integral = 0
    ordinates = floor((bx-ax)/interval)

    if ordinates < 30 then
        ordinates = 30
    end if

    dx = (bx-ax)/(ordinates)
    z1 = (ax-mux)/sigmax
    integral += E(-z1*z1/2)
    integral += E(-(bx-dx)*(bx-dx)/2)
    dx /= sigmax

    for tx = 1 to ordinates-1 do

        z1 += dx

        integral += 2*E(-z1*z1/2)

    end for

    integral *= dx/sqrt(8*pi)

    return integral
end function

object temp

function GetXLimits()
    sequence limits
    limits = {0,0}
    puts(1,"Enter Max X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Min X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    return limits
end function

function GetYLimits()
    sequence limits
    limits = {0,0,0}
    puts(1,"Enter Max Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Min Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    puts(1,"Enter rho val ")
    temp = gets(0)
    puts(1,"\n")
    limits[3] = ToNum(temp)
    return limits
end function

function GetXSpec()
    sequence limits
    limits = {0,0}
    puts(1,"Enter Mu X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Sigma X val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    return limits
end function

function GetYSpec()
    sequence limits
    limits = {0,0}
    puts(1,"Enter Mu Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[1] = ToNum(temp)
    puts(1,"Enter Sigma Y val ")
    temp = gets(0)
    puts(1,"\n")
    limits[2] = ToNum(temp)
    return limits
end function

atom QUIT,val
sequence limits,spec

limits = {0,0,0,0,0}
spec = {0,0,0,0}
QUIT = 0

while QUIT = 0 do
    puts(1,"(u)ni- or (b)i- variate data?")
    temp = wait_key()
    puts(1,"\n")
    if temp = 'u' then
        puts(1,"(s)tandard or s(p)ecific data?")
        temp = wait_key()
        puts(1,"\n")

        if temp = 's' then
	    limits = GetXLimits()
	    val = GenNormalInt({0}&{1}&limits)
        elsif temp = 'p' then
	    spec = GetXSpec()
	    limits = GetXLimits()
	    val = GenNormalInt(spec&limits)
        else
	    puts(1,"what?????")
	    puts(1,"\n")
	    val = -1
        end if

    elsif temp = 'b' then
        puts(1,"(s)tandard or s(p)ecific data?")
        temp = wait_key()
        puts(1,"\n")

        if temp = 's' then
	    limits = GetXLimits()&GetYLimits()
	    val = GenBiVariateInt({0}&{1}&{0}&{1}&limits)
        elsif temp = 'p' then
	    spec = GetXSpec()&GetYSpec()
	    limits = GetXLimits()&GetYLimits()
	    val = GenBiVariateInt(spec&limits)
        else
	    puts(1,"what?????")
	    puts(1,"\n")
	    val = -1
        end if
    else
        puts(1,"what?????")
        puts(1,"\n")
        val = -1
    end if
    printf(1,"\n%1.4g\n", val)
    puts(1,"Another?")
    temp = wait_key()
    if temp != 'y' then
        QUIT = 1
    end if
    puts(1,"\n")
    integral = 0
end while


